import java.io.*;

public class FichierTexte{

private static final String ERREUR_OUVERTURE =
    "erreur ouverture fichier "; 
private static final String NON_OUVERT =
    "fichier non ouvert";
private static final String ERREUR_LECTURE = 
    "erreur de lecture dans le fichier ";
private static final String ERREUR_ECRITURE = 
    "erreur d'ecriture dans le fichier ";
private static final String ERREUR_FERMETURE =
    "erreur fermeture fichier ";
private static final String ERREUR_MODE = 
    "mode incorrect ('r ou w')";

private static final  BufferedReader CLAVIER = 
    new BufferedReader(new InputStreamReader(System.in));

    
    private BufferedReader in = null;
    private PrintWriter out = null;
    private String nomFichier;
    
    public FichierTexte(String nomFichier, char mode){
	try {
	    switch (mode){
	    case 'r' :
		in = new BufferedReader(new FileReader(nomFichier));
		this.nomFichier=nomFichier;
		break;
	    case 'w':
		out = new PrintWriter(new BufferedWriter(new FileWriter(nomFichier)));
		this.nomFichier=nomFichier;
		break;
	    default:
		throw new RuntimeException (ERREUR_MODE);
	    }   
	}catch( IOException e){
	    throw new RuntimeException(ERREUR_OUVERTURE + nomFichier);
	}
    }   
    

    private static String lireLigne() {
	String ligne="";
	try {
	    ligne = CLAVIER.readLine();
	}catch(IOException e){
	    // pas de traitement car aucune erreur d'entee-sortie
	    // dans le cas particulier du clavier
	}
	return ligne;
    }


    /** lecture d'une chaine au clavier */
    public static String lireChaine(){
	return lireLigne();
    }

    /** lecture d'un entier au clavier */
    public static int lireEntier() {
	try {
	    return Integer.parseInt(lireLigne());
	}catch(NumberFormatException e){
	    return lireEntier();
	}
    }
    /** lecture d'un double au clavier */
    public static double lireDouble() {
	try {
	    return Double.parseDouble(lireLigne());
	}catch(NumberFormatException e){
	    return lireDouble();
	}
    }

    
    /**lecture ligne a ligne dans un fichier
       retourne null si fin de fichier*/
    public String  lire(){
	if (in == null)
	    throw new RuntimeException(NON_OUVERT);
	 try{ 
	     return in.readLine();
	 }catch(IOException e){
	     throw new RuntimeException(ERREUR_LECTURE + nomFichier);
	 }
	 
    }
    
    // ecriture d'une chaine dans un fichier
    public void ecrire(String chaine) {
	if (out == null)
	    throw new RuntimeException(NON_OUVERT);
	out.println(chaine);
    }

    public void fermer(){
	try{
	    if (in != null){
		in.close();
		in = null;
	    }else{ 
		out.close();
		out = null;
	    }
	}catch(IOException e)
	    {
	    throw new RuntimeException(ERREUR_FERMETURE + nomFichier);
		
	    }
    }

}
