import java.io.*;

public class FichierTexteV1{

private static final String ERREUR_LECTURE = "erreur de lecture dans le fichier ";
private static final String ERREUR_ECRITURE = "erreur d'ecriture dans le fichier ";

private static final  BufferedReader CLAVIER = new BufferedReader(new InputStreamReader(System.in));



    // lecture d'une chaine au clavier
    public static String lireClavier() {
	String ligne="";
	try {
	    ligne = CLAVIER.readLine();
	}catch(IOException e){
	    // pas de traitement car aucune erreur d'entee-sortie
	    // dans le cas particulier du clavier
	}
	return ligne;
    }

    //lecture ligne a ligne dans un fichier
     public static void lire(String nomFichier){

	String ligne;
	try{
	    BufferedReader entree = new BufferedReader(new FileReader(nomFichier));
	    while((ligne = entree.readLine()) != null)
		System.out.println(ligne);
	    entree.close();
	}catch(IOException e){
	    throw new RuntimeException(ERREUR_LECTURE + nomFichier);
	}

     }

    // ecriture d'une chaine dans un fichier
    public static void ecrire(String nomFichier, String chaine) {
	try{
	   PrintWriter out= new PrintWriter(new BufferedWriter(
				   new FileWriter(nomFichier)));
	   out.println(chaine);
	   out.close();
	}catch(IOException e){
	    throw new RuntimeException(ERREUR_ECRITURE + nomFichier);
	}
    }

    public static void main(String arg[]){
	System.out.print("Saisir votre chaine : ");
	String s = lireClavier();
	ecrire("toto.txt", s);
	lire("toto.txt");
	System.out.println("Le fichier source ");
	lire ("FichierTexteV1.java");
    }
}
